module UU
  module OS
    module Lang

      # Module providing extension of {Hash} to be able to
      # access stored data in accessor based manner.
      module HashAccessor

        # Transforms call of unknown method to accessor (using symbol keys).
        # @raise [NoMethodError] In case method does not match accessor syntax
        #    or {Hash} does not contain matching key.
        def method_missing(method, *args, &block)
          if args.size == 0 && has_key?(method)
            return self[method]
          elsif method =~ /=$/ && args.size == 1
            key = method.to_s[0..-2].to_sym
            if has_key?(key)
              return self[key] = args[0]
            else
              return super(method, *args, &block)
            end
          else
            return super(method, *args, &block)
          end
        end

      end

    end
  end
end
